#include "CloudFactory.h"
#include "DBoxClient.h"
#include "GDriveClient.h"

using namespace cloud::dbox;
using namespace cloud::gdrive;

namespace cloud {

FileSystem* DBoxFactory::CreateFileSystem()
{
  return new DBoxFileSystem();
}

File* DBoxFactory::CreateFile()
{
  return new DBoxFile();
}

Folder* DBoxFactory::CreateFolder()
{
  return new DBoxFolder();
}

DBoxFactory::~DBoxFactory()
{
}

FileSystem* GDriveFactory::CreateFileSystem()
{
  return new GDriveFileSystem();
}

File* GDriveFactory::CreateFile()
{
  return new GDriveFile();
}

Folder* GDriveFactory::CreateFolder()
{
  return new GDriveFolder();
}

GDriveFactory::~GDriveFactory()
{
}

} // namespace cloud
