#ifndef GDRIVE_H
#define GDRIVE_H

#include "Cloud.h"

using cloud::FileSystem;
using cloud::File;
using cloud::Folder;

// Work around compilers that don't support C++11.
#define override

namespace cloud {
namespace gdrive {

class GDriveFileSystem: public FileSystem
{
public:
  virtual void Connect(const char *aHost, uint16_t aPort) override;
  virtual bool IsConnected() override;
  virtual void Disconnect() override;

  virtual ~GDriveFileSystem() override;
};

class GDriveFile: public File
{
public:
  virtual const char * GetName() const override;
  virtual void Delete() override;

  virtual ~GDriveFile() override;

};

class GDriveFolder: public Folder
{
public:
  virtual void Delete() override;

  virtual ~GDriveFolder() override;
};

} // namespace gdrive
} // namespace cloud

#endif
