#include <gtkmm.h>

#include "MediatorInterface.h"

class AddButton;
class DeleteButton;

class AppWindow : public Gtk::Window
                , public Mediator
{
public:
  AppWindow();
  virtual ~AppWindow() {}

  virtual void ChangeState(Colleague* aSource) override;

private:
  AddButton* mAddButton;
  DeleteButton* mDeleteButton;
  Gtk::Entry mInputField;
  Gtk::ListViewText mListView;
  Gtk::Fixed mFixedContainer;
};

class AddButton : public Gtk::Button
                , public Colleague
{
public:
  AddButton(AppWindow* aMediator);
  ~AddButton() {}

  void RegisterEventHandler();

protected:
  // Overrides default handler when the button is clicked.
  virtual void on_clicked() override;

private:
  Mediator* mMediator;
};

class DeleteButton : public Gtk::Button
                   , public Colleague
{
public:
  DeleteButton(AppWindow* aMediator);
  ~DeleteButton() {}

  void RegisterEventHandler();

protected:
  // Overrides default handler when the button is clicked.
  virtual void on_clicked() override;

private:
  void on_click();

  AppWindow* mMediator;
};
