#ifndef GDRIVECLIENT_H
#define GDRIVECLIENT_H

#include "Cloud.h"
#include "vendor/GDriveConnector.h"

namespace cloud {
namespace gdrive {

class GDriveFileSystem: public FileSystem {
public:
  virtual void Connect(const char *aHost, uint16_t aPort);
  virtual bool IsConnected();
  virtual void Disconnect();

  virtual ~GDriveFileSystem();

private:
  impl::gdrive_storage *mImpl;
};

class GDriveFile: public File
{
  virtual const char * GetName() const;
  virtual void Delete();

  virtual ~GDriveFile();

private:
  impl::gdrive_file *mImpl;
};

class GDriveFolder: public Folder
{
public:
  virtual void Delete();

  virtual ~GDriveFolder();

private:
  impl::gdrive_directory *mImpl;
};

} // namespace gdrive
} // namespace cloud

#endif
