#ifndef CLOUD_H
#define CLOUD_H

#include <stdint.h>
#include <vector>

namespace cloud {

class File;
class Folder;

class FileSystem
{
public:
  virtual void Connect(const char *aHost, uint16_t aPort) = 0;
  virtual void Disconnect() = 0;
  virtual bool IsConnected() = 0;

  virtual ~FileSystem() {}

};

class File
{
public:
  virtual const char * GetName() const = 0;
  virtual void Delete() = 0;
  virtual ssize_t Read(uint8_t *aBuff, ssize_t aBuffLen) = 0;
  virtual ssize_t Write(uint8_t *aBuff, ssize_t aBuffLen) = 0;

  virtual ~File() {}
};

class Folder
{
public:
  virtual void Delete() = 0;

  virtual ~Folder() {}
};

}

#endif
